<script setup lang="ts">
import { ref } from 'vue'
import type { ComponentPublicInstance } from 'vue'

import { DefaultApi, Configuration } from '../../openapi/generated'

import MemoInput from '../molecules/MemoInput.vue'
import MemoSearcher from '../organisms/MemoSearcher.vue'
import MemoCard from '../organisms/MemoCard.vue'
import FormPostMemo from '../organisms/FormPostMemo.vue'

// var
const count = ref(0)
const memoMap = ref({})
const newMemoText = ref('')
const newMemoTag = ref('')

const memolist = ref<ComponentPublicInstance | null>(null)

// init api
const conf = new Configuration({
  basePath: 'http://localhost:1323',
})
const api = new DefaultApi(conf)


// load memos
api.findMemos().then(memos => {
  console.log(memos)
  memos.map(memo => {
    memoMap.value[memo.id] = memo
  })
})


// func
const scrollToMemoListBottom = () => {
  const children = memolist.value.children
  const el = children[children.length - 1]

  el.scrollIntoView()
}
</script>

<template>
  <div class="container-fluid">
    <header class="container-fluid">
      <nav class="navbar navbar-light bg-light">
        <div class="container-fluid">
          <a class="navbar-brand">header</a>
          <div class="d-flex">
            <MemoSearcher
              class="me-2"
              type="text"
              @search="(result) => memoMap = result"
            />

            <MemoSearcher
              class="me-2"
              type="tag"
              @search="(result) => memoMap = result"
            />
          </div>
        </div>
      </nav>
    </header>
  
    <main class="container-fluid">
      <ul class="memolist h-75 w-75 mx-auto list-group overflow-scroll" ref="memolist">
        <li class="list-group-item" v-for="(value, key, index) in memoMap">
          <MemoCard
            :memo="value"
            @update="(result) => memoMap[result.id] = result"
            @delete="(result) => delete memoMap[result]"
          />
        </li>
      </ul>
    
      <FormPostMemo
        class="w-75 mx-auto"
        @add="(result) => { memoMap[result.id] = result ; scrollToMemoListBottom(); }"
      />
  
    </main>
  
    <footer class="container-fluid bg-light">
    </footer>
  </div>
</template>

<style scoped>
.flex {
  display: flex;
}

header{
    height:10vh;
}

main{
    height:80vh;
}

footer{
    height:10vh;
}

</style>
